# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2018 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2018, Creative Commons
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""
from pynfe.xml_sped.base import TagCaracter, TagInteiro, TagDecimal
from . import ESQUEMA_ATUAL
from .base import XMLMDFe, NAMESPACE_MDFE
import os


DIRNAME = os.path.dirname(__file__)


class ConsSitMDFe(XMLMDFe):
    """Mensagem de consulta da situacao atual do MDF-e."""
    def __init__(self):
        super(ConsSitMDFe, self).__init__()
        self.versao = TagDecimal(
            nome='consSitMDFe', tamanho=[1, 4, 1], decimais=[0, 2, 2], propriedade='versao',
            raiz='/', valor='3.00', namespace=NAMESPACE_MDFE)
        self.tpAmb = TagInteiro(nome='tpAmb', tamanho=[1, 1], raiz='//consSitMDFe')
        self.xServ = TagCaracter(
            nome='xServ', tamanho=[9, 9], raiz='//consSitMDFe', valor='CONSULTAR')
        self.chMDFe = TagCaracter(nome='chMDFe', tamanho=[44, 44], raiz='//consSitMDFe')
        self.caminho_esquema = os.path.join(DIRNAME, 'schema/', ESQUEMA_ATUAL + '/')
        self.arquivo_esquema = 'consSitMDFe_v3.00.xsd'

    @property
    def xml(self):
        xml = '<consSitMDFe xmlns="%s" versao="%s">' % (NAMESPACE_MDFE, self.versao.valor)
        xml += self.tpAmb.xml
        xml += self.xServ.xml
        xml += self.chMDFe.xml
        xml += '</consSitMDFe>'
        return xml

    @xml.setter
    def xml(self, arquivo):
        self.versao.xml = arquivo
        self.tpAmb.xml = arquivo
        self.xServ.xml = arquivo
        self.chMDFe.xml = arquivo

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
