# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2018 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2018, Creative Commons
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""
from pynfe.xml_sped.base import TagCaracter, TagDecimal
from .base import XMLMDFe, NAMESPACE_MDFE
from . import ESQUEMA_ATUAL
from .MDFe import MDFe
import os


DIRNAME = os.path.dirname(__file__)


class EnviMDFe(XMLMDFe):
    """Mensagem de envio e solicitacao de autorizacao do MDF-e."""
    def __init__(self):
        super(EnviMDFe, self).__init__()
        self.versao = TagDecimal(
            nome='enviMDFe', tamanho=[1, 4, 1], decimais=[0, 2, 2], propriedade='versao',
            raiz='/', namespace=NAMESPACE_MDFE, valor='3.00')
        self.idLote = TagCaracter(nome='idLote', tamanho=[1, 15], raiz='//enviMDFe')
        self.mdfe = []  # Obrigatorio - Maximo 1 (no futuro podera conter mais de um MDF-e)
        self.caminho_esquema = os.path.join(DIRNAME, 'schema/', ESQUEMA_ATUAL + '/')
        self.arquivo_esquema = 'enviMDFe_v3.00.xsd'

    @property
    def xml(self):
        xml = ''
        xml += self.mdfe.raw_xml()

        return xml

    @xml.setter
    def xml(self, arquivo):
        self.versao.xml = arquivo
        self.mdfe = self.le_grupo('//envMDFe', MDFe)

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

