# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2018 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2018, Creative Commons
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""
from pynfe.xml_sped.base import TagDecimal
from .base import XMLMDFe, NAMESPACE_MDFE
from .retEventoMDFe import RetEventoMDFe
from .eventoMDFe import EventoMDFe
from . import ESQUEMA_ATUAL
import os


DIRNAME = os.path.dirname(__file__)


class ProcEventoMDFe(XMLMDFe):
    """Leiaute de compartilhamento de solicitação de registro de evento do MDF-e."""
    def __init__(self):
        super(ProcEventoMDFe, self).__init__()
        self.versao = TagDecimal(
            nome='procEventoMDFe', tamanho=[1, 4, 1], decimais=[0, 2, 2], propriedade='versao',
            raiz='/', namespace=NAMESPACE_MDFE, valor='3.00')
        self.evento = EventoMDFe()
        self.retEvento = RetEventoMDFe()
        self.caminho_esquema = os.path.join(DIRNAME, 'schema/', ESQUEMA_ATUAL + '/')
        self.arquivo_esquema = 'procEventoMDFe_v3.00.xsd'

    @property
    def xml(self):
        xml = '<procEventoMDFe xmlns="%s" versao="%s">' % (NAMESPACE_MDFE, self.versao.valor)
        xml += self.evento.raw_xml()
        xml += self.retEvento.raw_xml()
        xml += '</procEventoMDFe>'
        return xml

    @xml.setter
    def xml(self, arquivo):
        self.versao.xml = arquivo
        self.evento.xml = arquivo
        self.retEvento.xml = arquivo

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
