# -*- coding: utf-8 -*-

from ..manual_300 import consrecinfe_110
from pynfe.xml_sped.base import *
from . import ESQUEMA_ATUAL
from .nfe_200 import NFe
import os


DIRNAME = os.path.dirname(__file__)


class ConsReciNFe(consrecinfe_110.ConsReciNFe):
    def __init__(self):
        super(ConsReciNFe, self).__init__()
        self.versao = TagDecimal(nome='consReciNFe', codigo='BP02', propriedade='versao', namespace=NAMESPACE_NFE, valor='2.00', raiz='/')
        self.caminho_esquema = os.path.join(DIRNAME, 'schema/', ESQUEMA_ATUAL + '/') 
        self.arquivo_esquema = 'consReciNFe_v2.00.xsd'


class InfProt(consrecinfe_110.InfProt):
    def __init__(self):
        super(InfProt, self).__init__()
    

class ProtNFe(consrecinfe_110.ProtNFe):
    def __init__(self):
        super(ProtNFe, self).__init__()
        self.versao = TagDecimal(nome='protNFe', codigo='PR02', propriedade='versao', namespace=NAMESPACE_NFE, valor='2.00', raiz='/')
    

class RetConsReciNFe(consrecinfe_110.RetConsReciNFe):
    def __init__(self):
        super(RetConsReciNFe, self).__init__()
        self.versao = TagDecimal(nome='retConsReciNFe', codigo='BR02', propriedade='versao', namespace=NAMESPACE_NFE, valor='2.00', raiz='/')
        self.cMsg = TagCaracter(nome='cMsg', codigo='BR06b', tamanho=[4, 4], raiz='//retConsReciNFe', obrigatorio=False)
        self.xMsg = TagCaracter(nome='xMsg', codigo='BR06c', tamanho=[1, 200], raiz='//retConsReciNFe', obrigatorio=False)
        self.caminho_esquema = os.path.join(DIRNAME, 'schema/', ESQUEMA_ATUAL + '/') 
        self.arquivo_esquema = 'retConsReciNFe_v2.00.xsd'
        

    @property
    def xml(self):
        xml = XMLNFe.xml.fget(self)
        xml += self.versao.xml
        xml += self.tpAmb.xml
        xml += self.verAplic.xml
        xml += self.nRec.xml
        xml += self.cStat.xml
        xml += self.xMotivo.xml
        xml += self.cUF.xml
        xml += self.cMsg.xml
        xml += self.xMsg.xml
        
        for pn in self.protNFe:
            xml += pn.xml
            
        xml += '</retConsReciNFe>'
        return xml
        
    @xml.setter
    def xml(self, arquivo):
        if self._le_xml(arquivo):
            self.versao.xml = arquivo
            self.tpAmb.xml = arquivo
            self.verAplic.xml = arquivo
            self.nRec.xml = arquivo
            self.cStat.xml = arquivo
            self.xMotivo.xml = arquivo
            self.cUF.xml = arquivo
            self.cMsg.xml = arquivo
            self.xMsg.xml = arquivo
            self.protNFe = self.le_grupo('//retConsReciNFe/protNFe', ProtNFe)

            #
            # Monta o dicionário dos protocolos
            #
            for pn in self.protNFe:
                self.dic_protNFe[pn.infProt.chNFe.valor] = pn
       


class ProcNFe(consrecinfe_110.ProcNFe):
    def __init__(self):
        super(ProcNFe, self).__init__()
        self.versao = TagDecimal(nome='nfeProc', propriedade='versao', namespace=NAMESPACE_NFE, valor='2.00', raiz='/')
        self.NFe = NFe()
        self.protNFe = ProtNFe()
        self.caminho_esquema = os.path.join(DIRNAME, 'schema/', ESQUEMA_ATUAL + '/') 
        self.arquivo_esquema = 'procNFe_v2.00.xsd'
