# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2017 All Rights Reserved. Luiz Fernando Maciel França
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2017, Creative Commons
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""
import os
from pynfe.xml_sped.base import *
from pynfe.nfe.manual_500 import consstatserv_310
from .nfe_400 import ESQUEMA_ATUAL

DIRNAME = os.path.dirname(__file__)


class ConsStatServ(consstatserv_310.ConsStatServ):
    def __init__(self):
        super(ConsStatServ, self).__init__()
        self.versao = TagDecimal(nome='consStatServ', codigo='FP01', propriedade='versao',
                                 namespace=NAMESPACE_NFE, valor='4.00', raiz='/')
        self.caminho_esquema = os.path.join(DIRNAME, 'schema', ESQUEMA_ATUAL + '/')
        self.arquivo_esquema = 'consStatServ_v4.00.xsd'


class RetConsStatServ(consstatserv_310.RetConsStatServ):
    def __init__(self):
        super(RetConsStatServ, self).__init__()
        self.versao = TagDecimal(nome='retConsStatServ', codigo='FR01', propriedade='versao',
                                 namespace=NAMESPACE_NFE, valor='4.00', raiz='/')
        self.caminho_esquema = os.path.join(DIRNAME, 'schema', ESQUEMA_ATUAL + '/')
        self.arquivo_esquema = 'retConsStatServ_v4.00.xsd'
        self.dhRecbto = TagDataHoraUTC(nome='dhRecbto', codigo='FR08', raiz='//retConsStatServ')

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
